
Redmine - Patch #29190

Add link to container on attachment preview

2018-07-04 14:36 - Gregor Schmidt

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 4.0.0   

Description

Status quo

When displaying the attachment preview, there's currently no on-page way to navigate back to the attachment container. We're

relying on the browser back button here, which might be impossible, if somebody followed a direct link to the attachment.

The reason, why this is currently not implemented, is probably because attachments may belong to many different Redmine records

types and generating a link is therefore not straight forward. Also, plugins may bring their own attachable objects, which need to be

considered.

Proposal

The attached patch, adds a general link_to_record helper, which would generate general purpose links to any object within in

Redmine. This is further refined with the link_to_attachment_container helper, which behaves slightly different for projects and

versions. link_to_record for projects links to the project overview, link_to_attachment_container links to the files tab.

This method can then be used on the attachment view, to link to the proper container.

These new methods are currently implemented for all records within Redmine core, which are either attachable or customizable

(since Redmine 4.0 will also support file custom fields).

Extensibility

The methods are implemented via an Hash of Procs. This should enable plugin authors to extend them easily, if their records can

have attachments as well.

In the future, link_to_record may be further extended to support all Redmine records. It may then become a general purpose helper

for whenever a generic link to an object is needed.

Tests

The patch provides tests for the new helpers. Futhermore, one other integration test needed to change, since the tested view is now

slightly different.

Preview

This is how it would look like:

 link-to-container.png 

Related issues:

Has duplicate Redmine - Feature #20422: Backlink for thumbnail-macro Closed

Associated revisions

Revision 17435 - 2018-07-08 02:27 - Go MAEDA

Adds link to container to attachment view (#29190).

Patch by Gregor Schmidt.

History

#1 - 2018-07-04 14:39 - Gregor Schmidt

This patch also handles file custom field attachments for groups. In theory this would not be necessary, since there is no UI to navigate to such an
attachment. Therefore I've also proposed #29189, which would add this UI.

#2 - 2018-07-04 16:08 - Go MAEDA

- Target version set to Candidate for next major release

It is a nice improvement! I have been annoyed for a long time that there is no way to know/see the container object of an attachment.

#3 - 2018-07-04 16:12 - Gregor Schmidt

Yes, this was also a common source of questions for Planio customers.

#4 - 2018-07-04 22:05 - Marius BĂLTEANU

+ 1

#5 - 2018-07-05 14:24 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

#6 - 2018-07-08 02:28 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

Committed. Thank you for improving Redmine.

#7 - 2019-10-14 11:58 - Go MAEDA

- Has duplicate Feature #20422: Backlink for thumbnail-macro added
